Package com.smartgwt.client.widgets

# Class FieldPicker

java.lang.Object
com.google.gwt.user.client.ui.UIObject
com.google.gwt.user.client.ui.Widget
com.smartgwt.client.widgets.BaseWidget
com.smartgwt.client.widgets.Canvas
com.smartgwt.client.widgets.layout.Layout
com.smartgwt.client.widgets.layout.VLayout
com.smartgwt.client.widgets.FieldPicker

All Implemented Interfaces:
  `HasAttachHandlers`, `HasHandlers`, `EventListener`, `HasVisibility`, `IsWidget`, `LogicalStructure`, `HasClearHandlers`, `HasClickHandlers`, `HasDoubleClickHandlers`, `HasDragMoveHandlers`, `HasDragRepositionMoveHandlers`, `HasDragRepositionStartHandlers`, `HasDragRepositionStopHandlers`, `HasDragResizeMoveHandlers`, `HasDragResizeStartHandlers`, `HasDragResizeStopHandlers`, `HasDragStartHandlers`, `HasDragStopHandlers`, `HasDropHandlers`, `HasDropMoveHandlers`, `HasDropOutHandlers`, `HasDropOverHandlers`, `HasFocusChangedHandlers`, `HasHoverHandlers`, `HasHoverHiddenHandlers`, `HasKeyDownHandlers`, `HasKeyPressHandlers`, `HasMouseDownHandlers`, `HasMouseMoveHandlers`, `HasMouseOutHandlers`, `HasMouseOverHandlers`, `HasMouseStillDownHandlers`, `HasMouseUpHandlers`, `HasMouseWheelHandlers`, `HasMovedHandlers`, `HasParentMovedHandlers`, `HasResizedHandlers`, `HasRightMouseDownHandlers`, `HasRuleContextChangedHandlers`, `HasScrolledHandlers`, `HasShowContextMenuHandlers`, `HasVisibilityChangedHandlers`, `HasMembersChangedHandlers`

public class FieldPicker extends VLayout
FieldPicker provides a configuration dialog that displays, side-by-side, the available and currently-displayed fields of a `DataBoundComponent`. It allows for easy customization of the order in which the fields of a `DataBoundComponent` are displayed, and of which are visible. If so configured, it also allows for convenient launching of the HiliteEditor, FormulaBuilder, and SummaryBuilder. A FieldPicker instance runs in its own window, a `FieldPickerWindow`

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

  `UIObject.DebugIdImpl, UIObject.DebugIdImplEnabled`

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

  `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

  ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

  `DEBUG_ID_PREFIX`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `FieldPicker()`
  `FieldPicker(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `changeAutoChildDefaults(String autoChildName, Canvas defaults)`
  Changes the defaults for Canvas AutoChildren named `autoChildName`.
  `static void`
  `changeAutoChildDefaults(String autoChildName, FormItem defaults)`
  Changes the defaults for FormItem AutoChildren named `autoChildName`.
  `protected JavaScriptObject`
  `create()`
  `String`
  `getAddCustomFieldsButtonTitle()`
  The title displayed for the Add Custom Fields Button
  `ListGrid`
  `getAvailableFieldsGrid()`
  A `ListGrid` showing the list of available fields.
  `Canvas[]`
  `getAvailableFieldsHeaderControls()`
  Provides a set of controls to appear as `section header controls` above the available fields grid.
  `String`
  `getAvailableFieldsTitle()`
  `String`
  `getAvailableTitleTitle()`
  The title displayed for the title property of the available fields
  `HLayout`
  `getButtonLayout()`
  A `horizontal layout` used to show the `Save` and `Cancel` buttons.
  `String`
  `getCancelButtonTitle()`
  The title shown on the Cancel button
  `IButton`
  `getCancelChangesButton()`
  An AutoChild `button` that saves the current field-set and exits the Field Picker.
  `Boolean`
  `getCanFilterSampleValue()`
  Whether the current fields' filter row allows the sample value column to be filtered.
  `String`
  `getConfirmText()`
  `ListGrid`
  `getCurrentFieldsGrid()`
  A `ListGrid` showing the list of currently selected fields.
  `String`
  `getCurrentFieldsTitle()`
  `String`
  `getCurrentTitleTitle()`
  The title displayed for the title property of the current fields
  `Canvas`
  `getDataBoundComponent()`
  The component whose fields should be edited.
  `DataSource`
  `getDataSource()`
  An optional DataSource that is used to create a disposable `dataBoundComponent` if none is provided.
  `String`
  `getEmptyTitleHint()`
  The hint shown when editing a field with no title defined.
  `String`
  `getHilitesText()`
  `Label`
  `getInstructionLabel()`
  A `label` displaying the text assigned as the FieldPicker's `instructions`.
  `String`
  `getInstructions()`
  `LogicalStructureObject`
  `getLogicalStructure()`
  Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `static FieldPicker`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `String`
  `getRemoveItemTitle()`
  The title shown on the 'Visible Fields' grid's context menu item, whose click handler puts the selected item back in the 'Available Fields' collection.
  `String`
  `getRemoveText()`
  `Record`
  `getSampleRecord()`
  If a `sampleRecord` is provided, the FieldPicker will show a second column in the Current Fields dialog showing the cell value that will appear for that field given the provided sample record.
  `DefaultSampleRecord`
  `getSampleRecordAsDefaultSampleRecord()`
  If a `sampleRecord` is provided, the FieldPicker will show a second column in the Current Fields dialog showing the cell value that will appear for that field given the provided sample record.
  `String`
  `getSampleValueTitle()`
  The title displayed for the sample value property of the current fields
  `IButton`
  `getSaveAndExitButton()`
  An AutoChild `button` that saves the current field-set and exits the Field Picker.
  `String`
  `getSaveAndExitButtonTitle()`
  The title shown on the Save and Exit button
  `boolean`
  `getShowFieldOrderButtons()`
  When set to false, hides the right-most set of buttons, used for re-ordering fields in the Visible Fields list.
  `boolean`
  `getShowHilitesButton()`
  Shows a "Highlights..." button that shows an interface for editing hilites in the attached DataBoundComponent.
  `FieldPicker`
  `setAddCustomFieldsButtonTitle(String addCustomFieldsButtonTitle)`
  The title displayed for the Add Custom Fields Button
  `void`
  `setAvailableFields(DataSourceField... newFields)`
  Provides a new set of available fields.
  `FieldPicker`
  `setAvailableFieldsHeaderControls(Canvas... availableFieldsHeaderControls)`
  Provides a set of controls to appear as `section header controls` above the available fields grid.
  `FieldPicker`
  `setAvailableFieldsTitle(String availableFieldsTitle)`
  `FieldPicker`
  `setAvailableTitleTitle(String availableTitleTitle)`
  The title displayed for the title property of the available fields
  `void`
  `setCallbackCustomizer(FieldPickerCallbackCustomizer customizer)`
  This method is called during rendering for all events in the visible range - those which would be rendered by default.
  `FieldPicker`
  `setCancelButtonTitle(String cancelButtonTitle)`
  The title shown on the Cancel button
  `FieldPicker`
  `setCanFilterSampleValue(Boolean canFilterSampleValue)`
  Whether the current fields' filter row allows the sample value column to be filtered.
  `FieldPicker`
  `setConfirmText(String confirmText)`
  `FieldPicker`
  `setCurrentFieldsTitle(String currentFieldsTitle)`
  `FieldPicker`
  `setCurrentTitleTitle(String currentTitleTitle)`
  The title displayed for the title property of the current fields
  `FieldPicker`
  `setDataBoundComponent(Canvas dataBoundComponent)`
  The component whose fields should be edited.
  `FieldPicker`
  `setDataSource(DataSource dataSource)`
  An optional DataSource that is used to create a disposable `dataBoundComponent` if none is provided.
  `static void`
  `setDefaultProperties(FieldPicker fieldPickerProperties)`
  Class level method to set the default properties of this class.
  `FieldPicker`
  `setEmptyTitleHint(String emptyTitleHint)`
  The hint shown when editing a field with no title defined.
  `FieldPicker`
  `setHilitesText(String hilitesText)`
  `FieldPicker`
  `setInstructions(String instructions)`
  `LogicalStructureObject`
  `setLogicalStructure(FieldPickerLogicalStructure s)`
  Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `FieldPicker`
  `setRemoveItemTitle(String removeItemTitle)`
  The title shown on the 'Visible Fields' grid's context menu item, whose click handler puts the selected item back in the 'Available Fields' collection.
  `FieldPicker`
  `setRemoveText(String removeText)`
  `FieldPicker`
  `setSampleRecord(Record sampleRecord)`
  If a `sampleRecord` is provided, the FieldPicker will show a second column in the Current Fields dialog showing the cell value that will appear for that field given the provided sample record.
  `FieldPicker`
  `setSampleRecord(DefaultSampleRecord sampleRecord)`
  If a `sampleRecord` is provided, the FieldPicker will show a second column in the Current Fields dialog showing the cell value that will appear for that field given the provided sample record.
  `FieldPicker`
  `setSampleValueTitle(String sampleValueTitle)`
  The title displayed for the sample value property of the current fields
  `FieldPicker`
  `setSaveAndExitButtonTitle(String saveAndExitButtonTitle)`
  The title shown on the Save and Exit button
  `FieldPicker`
  `setShowFieldOrderButtons(boolean showFieldOrderButtons)`
  When set to false, hides the right-most set of buttons, used for re-ordering fields in the Visible Fields list.
  `FieldPicker`
  `setShowHilitesButton(boolean showHilitesButton)`
  Shows a "Highlights..." button that shows an interface for editing hilites in the attached DataBoundComponent.

  ### Methods inherited from class com.smartgwt.client.widgets.layout.VLayout

  `setDefaultProperties, setLogicalStructure`

  ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

  `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getChildTabPosition, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEditProxyConstructor, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutEndMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutStartMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersAsStringArray, getMembersLength, getMembersMargin, getMinMemberLength, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit, onInit_Layout, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, replaceMember, revealChild, revealChild, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEditProxyConstructor, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutEndMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutStartMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembers, setMembersMargin, setMinBreadthMember, setMinBreadthMember, setMinBreadthMember, setMinMemberLength, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

  ### Methods inherited from class com.smartgwt.client.widgets.Canvas

  `addChild, addChild, addChild, addChild, addChild, addClearHandler, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addRuleContextChangedHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clearExplicitTabIndex, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsEventTarget, containsFocus, containsPoint, containsPoint, contentsComponentConnected, dataContextChanged, dataContextCriteriaChanged, deparent, depeer, disable, doValueDictation, doVoiceCommand, enable, encloses, endBatchCreation, focus, focusAfterGroup, focusAtEnd, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAdaptiveHeightPriority, getAdaptiveWidthPriority, getAllCanvases, getAllCanvases, getAllCanvases, getAlwaysManageFocusNavigation, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideEffect, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeLayoutMode, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaHandleID, getAriaRole, getAriaStateDefaults, getAutoMaskComponents, getAutoParent, getAutoPopulateData, getAutoRevertStyles, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBorderRadius, getBorderRadiusAsString, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanAdaptHeight, getCanAdaptWidth, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanDropContent, getCanDropFiles, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenAsStringArray, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContentsComponentDefaults, getContextMenu, getControlHeight, getCorrectZoomOverflow, getCursor, getDataContext, getDataContextCriteria, getDataContextCriteria, getDataPath, getDefaultHeight, getDefaultWidth, getDeferActionConversion, getDefiningProperty, getDefiningPropertyName, getDefiningPropertyNameOptions, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragMaxHeight, getDragMaxWidth, getDragMinHeight, getDragMinWidth, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragTargetAsString, getDragType, getDropTarget, getDropTargetAsString, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEnableWhen, getEndLine, getEventEdge, getEventEdge, getEvents, getExtraSpace, getFacetId, getFloatingScrollbars, getFormItemAutoChild, getForwardSVGeventsToObject, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupPadding, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverAutoFitMaxWidth, getHoverAutoFitMaxWidthAsString, getHoverAutoFitWidth, getHoverComponent, getHoverDelay, getHoverFocusKey, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverPersist, getHoverScreen, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlElementAsString, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsRuleScope, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeaveGroupLabelSpace, getLeavePageSpace, getLeft, getLeftAsString, getLocalId, getLocateByIDOnly, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getLocatorName, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMatchElementHeight, getMatchElementWidth, getMaxHeight, getMaxWidth, getMaxZoomOverflowError, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getName, getNativeAutoHideScrollbars, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPaletteDefaults, getPanelContainer, getParentCanvas, getParentCanvasAsString, getParentElement, getParentElementAsString, getPeers, getPendingMarkerStyle, getPendingMarkerVisible, getPercentBox, getPercentSource, getPersistentMatchElement, getPointerSettings, getPointerTarget, getPointerTargetAsString, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrintStyleName, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getReceiveScrollbarEvents, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getRuleContext, getRuleContext, getRuleScope, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowColor, getShadowDepth, getShadowHOffset, getShadowImage, getShadowOffset, getShadowSoftness, getShadowSpread, getShadowVOffset, getShareCriteria, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowFocusOutline, getShowHover, getShowHoverComponents, getShowPointer, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSingleDiv, getSizeMayChangeOnRedraw, getSkinImgDir, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapGridLineProperties, getSnapGridStyle, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStartLine, getStyleName, getSuppressRedraw, getTabIndex, getTestDataContext, getTestInstance, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getTopLevelComponents, getUpdateTabPositionOnDraw, getUpdateTabPositionOnReparent, getUseBackMask, getUseCSSShadow, getUseDataContextCriteria, getUseDragMask, getUseGeneratedStyles, getUseImageForSVG, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getValuesManagerAsString, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWhen, getVisibleWidth, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getWorkflows, getZIndex, getZIndex, handleDataContextCriteria, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, initComplete, intersects, isDirty, isDisabled, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, print, print, print, print, printComponents, provideRuleContext, provideRuleContext, redraw, redraw, registerAIService, registerFontScaledPaddingStyles, removeChild, removeChild, removePeer, removePeer, removeRuleContext, removeSnapAlignCandidate, resizeAutoChildAttributes, resizeBy, resizeControls, resizeControlsTo, resizeFonts, resizeFonts, resizeFonts, resizeFontsTo, resizeIcons, resizePadding, resizePadding, resizeTo, resizeTo, resolveContentsComponent, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAdaptHeightByCustomizer, setAdaptiveHeightPriority, setAdaptiveWidthPriority, setAdaptWidthByCustomizer, setAllowExternalFilters, setAlwaysManageFocusNavigation, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideEffect, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeLayoutMode, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoHeight, setAutoMaskComponents, setAutoParent, setAutoPopulateData, setAutoResizeAutoChildAttributes, setAutoResizeIcons, setAutoRevertStyles, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBorderRadius, setBorderRadius, setBottom, setCanAcceptDrop, setCanAdaptHeight, setCanAdaptWidth, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanDropContent, setCanDropFiles, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContentsComponentDefaults, setContextMenu, setCorrectZoomOverflow, setCursor, setDataContext, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataPath, setDefaultHeight, setDefaultNativeAutoHideScrollbars, setDefaultPageSpace, setDefaultProperties, setDefaultShowCustomScrollbars, setDefaultWidth, setDeferActionConversion, setDefiningProperty, setDefiningPropertyNameOptions, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragMaxHeight, setDragMaxWidth, setDragMinHeight, setDragMinWidth, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragTarget, setDragType, setDropTarget, setDropTarget, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setEnableWhen, setEndLine, setExtraSpace, setFacetId, setFloatingScrollbars, setForwardSVGeventsToObject, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupPadding, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverAutoFitMaxWidth, setHoverAutoFitMaxWidth, setHoverAutoFitWidth, setHoverDelay, setHoverFocusKey, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverPersist, setHoverScreen, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsRuleScope, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeaveGroupLabelSpace, setLeavePageSpace, setLeft, setLeft, setLocateByIDOnly, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLocatorName, setLocatorParent, setLocatorParent, setLogicalStructure, setMargin, setMatchElement, setMatchElementHeight, setMatchElementWidth, setMaxHeight, setMaxWidth, setMaxZoomOverflowError, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setName, setNativeAutoHideScrollbars, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setPanelContainer, setParentCanvas, setParentCanvas, setParentElement, setParentElement, setPeers, setPendingMarkerStyle, setPendingMarkerVisible, setPercentBox, setPercentSource, setPersistentMatchElement, setPointerSettings, setPointerTarget, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrintStyleName, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setReceiveScrollbarEvents, setRect, setRect, setRedrawOnResize, setRelativeTabPosition, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setRuleScope, setScrollbarConstructor, setScrollbarSize, setShadowColor, setShadowDepth, setShadowHOffset, setShadowImage, setShadowOffset, setShadowSoftness, setShadowSpread, setShadowVOffset, setShareCriteria, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowFocusOutline, setShowHover, setShowHoverComponents, setShowPointer, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSingleDiv, setSizeMayChangeOnRedraw, setSkinImgDir, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapGridLineProperties, setSnapGridStyle, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStartLine, setStyleName, setSuppressRedraw, setTabIndex, setTestDataContext, setTitle, setTooltip, setTop, setTop, setUpdateTabPositionOnDraw, setUpdateTabPositionOnReparent, setUseBackMask, setUseCSSShadow, setUseDataContextCriteria, setUseDragMask, setUseGeneratedStyles, setUseImageForSVG, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setValuesManager, setVisibility, setVisible, setVisibleWhen, setWidth, setWidth, setWidth, setWidth100, setWorkflows, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPendingMarker, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, startBatchCreation, startDebuggingOverflow, stopDebuggingOverflow, subtractRects, supportsValueDictation, supportsVoiceCommands, unregisterAIService, updateChildTabPosition, updateChildTabPositions, updateEditNode, updateHover, updateHover, updateShadow, updateTabPositionForDraw, visibleAtPoint, willAcceptDrop`

  ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

  `addDrawHandler, addDynamicProperty, addDynamicProperty, addDynamicProperty, addDynamicProperty, applyFactoryProperties, clearDynamicProperty, completeCreation, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAutoDraw, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hasDynamicProperty, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isDrawn, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoDraw, setConfig, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

  ### Methods inherited from class com.google.gwt.user.client.ui.Widget

  `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

  ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

  `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

  `fireEvent`

- ## Constructor Details

  - ### FieldPicker

    public FieldPicker()

  - ### FieldPicker

    public FieldPicker(JavaScriptObject jsObj)

- ## Method Details

  - ### getOrCreateRef

    public static FieldPicker getOrCreateRef(JavaScriptObject jsObj)

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, Canvas defaults)
    Changes the defaults for Canvas AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, FormItem defaults)
    Changes the defaults for FormItem AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### create

    protected JavaScriptObject create()
    Overrides:
      `create` in class `VLayout`

  - ### setAddCustomFieldsButtonTitle

    public FieldPicker setAddCustomFieldsButtonTitle(String addCustomFieldsButtonTitle) throws IllegalStateException
    The title displayed for the Add Custom Fields Button
    Parameters:
      `addCustomFieldsButtonTitle` - New addCustomFieldsButtonTitle value. Default value is "Add Custom Fields"
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getAddCustomFieldsButtonTitle

    public String getAddCustomFieldsButtonTitle()
    The title displayed for the Add Custom Fields Button
    Returns:
      Current addCustomFieldsButtonTitle value. Default value is "Add Custom Fields"

  - ### getAvailableFieldsGrid

    public ListGrid getAvailableFieldsGrid() throws IllegalStateException
    A `ListGrid` showing the list of available fields.

    This component is an AutoChild named "availableFieldsGrid". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current availableFieldsGrid value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setAvailableFieldsHeaderControls

    public FieldPicker setAvailableFieldsHeaderControls(Canvas... availableFieldsHeaderControls) throws IllegalStateException
    Provides a set of controls to appear as `section header controls` above the available fields grid.
    Parameters:
      `availableFieldsHeaderControls` - New availableFieldsHeaderControls value. Default value is null
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getAvailableFieldsHeaderControls

    public Canvas[] getAvailableFieldsHeaderControls()
    Provides a set of controls to appear as `section header controls` above the available fields grid.
    Returns:
      Current availableFieldsHeaderControls value. Default value is null

  - ### setAvailableFieldsTitle

    public FieldPicker setAvailableFieldsTitle(String availableFieldsTitle) throws IllegalStateException
    Parameters:
      `availableFieldsTitle` - New availableFieldsTitle value. Default value is "Available Fields"
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getAvailableFieldsTitle

    public String getAvailableFieldsTitle()
    Returns:
      Current availableFieldsTitle value. Default value is "Available Fields"

  - ### setAvailableTitleTitle

    public FieldPicker setAvailableTitleTitle(String availableTitleTitle) throws IllegalStateException
    The title displayed for the title property of the available fields
    Parameters:
      `availableTitleTitle` - New availableTitleTitle value. Default value is "Name"
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getAvailableTitleTitle

    public String getAvailableTitleTitle()
    The title displayed for the title property of the available fields
    Returns:
      Current availableTitleTitle value. Default value is "Name"

  - ### getButtonLayout

    public HLayout getButtonLayout() throws IllegalStateException
    A `horizontal layout` used to show the `Save` and `Cancel` buttons.

    This component is an AutoChild named "buttonLayout". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current buttonLayout value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setCancelButtonTitle

    public FieldPicker setCancelButtonTitle(String cancelButtonTitle) throws IllegalStateException
    The title shown on the Cancel button
    Parameters:
      `cancelButtonTitle` - New cancelButtonTitle value. Default value is "Cancel"
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getCancelButtonTitle

    public String getCancelButtonTitle()
    The title shown on the Cancel button
    Returns:
      Current cancelButtonTitle value. Default value is "Cancel"

  - ### getCancelChangesButton

    public IButton getCancelChangesButton() throws IllegalStateException
    An AutoChild `button` that saves the current field-set and exits the Field Picker.

    This component is an AutoChild named "cancelChangesButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current cancelChangesButton value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setCanFilterSampleValue

    public FieldPicker setCanFilterSampleValue(Boolean canFilterSampleValue) throws IllegalStateException
    Whether the current fields' filter row allows the sample value column to be filtered.
    Parameters:
      `canFilterSampleValue` - New canFilterSampleValue value. Default value is false
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `setSampleValueTitle(java.lang.String)`
      - `setSampleRecord(com.smartgwt.client.data.Record)`

  - ### getCanFilterSampleValue

    public Boolean getCanFilterSampleValue()
    Whether the current fields' filter row allows the sample value column to be filtered.
    Returns:
      Current canFilterSampleValue value. Default value is false
    See Also:
      - `getSampleValueTitle()`
      - `getSampleRecord()`

  - ### setConfirmText

    public FieldPicker setConfirmText(String confirmText) throws IllegalStateException
    Parameters:
      `confirmText` - New confirmText value. Default value is "Must save pending changes to proceed. OK?"
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getConfirmText

    public String getConfirmText()
    Returns:
      Current confirmText value. Default value is "Must save pending changes to proceed. OK?"

  - ### getCurrentFieldsGrid

    public ListGrid getCurrentFieldsGrid() throws IllegalStateException
    A `ListGrid` showing the list of currently selected fields.

    This component is an AutoChild named "currentFieldsGrid". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current currentFieldsGrid value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setCurrentFieldsTitle

    public FieldPicker setCurrentFieldsTitle(String currentFieldsTitle) throws IllegalStateException
    Parameters:
      `currentFieldsTitle` - New currentFieldsTitle value. Default value is "Visible Fields"
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getCurrentFieldsTitle

    public String getCurrentFieldsTitle()
    Returns:
      Current currentFieldsTitle value. Default value is "Visible Fields"

  - ### setCurrentTitleTitle

    public FieldPicker setCurrentTitleTitle(String currentTitleTitle) throws IllegalStateException
    The title displayed for the title property of the current fields
    Parameters:
      `currentTitleTitle` - New currentTitleTitle value. Default value is "Field Title"
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getCurrentTitleTitle

    public String getCurrentTitleTitle()
    The title displayed for the title property of the current fields
    Returns:
      Current currentTitleTitle value. Default value is "Field Title"

  - ### setDataBoundComponent

    public FieldPicker setDataBoundComponent(Canvas dataBoundComponent) throws IllegalStateException
    The component whose fields should be edited.

    Note that if `DataBoundComponent.useAllDataSourceFields` is set on the component, it will be cleared when the FieldPicker applies the requested ordering since that setting imposes a fixed ordering on the fields.

    Parameters:
      `dataBoundComponent` - New dataBoundComponent value. Default value is null
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getDataBoundComponent

    public Canvas getDataBoundComponent()
    The component whose fields should be edited.

    Note that if `DataBoundComponent.useAllDataSourceFields` is set on the component, it will be cleared when the FieldPicker applies the requested ordering since that setting imposes a fixed ordering on the fields.

    Returns:
      Current dataBoundComponent value. Default value is null

  - ### setDataSource

    public FieldPicker setDataSource(DataSource dataSource) throws IllegalStateException
    An optional DataSource that is used to create a disposable `dataBoundComponent` if none is provided. Has no effect if a `dataBoundComponent` is specified.
    Parameters:
      `dataSource` - New dataSource value. Default value is null
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getDataSource

    public DataSource getDataSource()
    An optional DataSource that is used to create a disposable `dataBoundComponent` if none is provided. Has no effect if a `dataBoundComponent` is specified.
    Returns:
      Current dataSource value. Default value is null

  - ### setEmptyTitleHint

    public FieldPicker setEmptyTitleHint(String emptyTitleHint) throws IllegalStateException
    The hint shown when editing a field with no title defined.
    Parameters:
      `emptyTitleHint` - New emptyTitleHint value. Default value is "[No title specified]"
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getEmptyTitleHint

    public String getEmptyTitleHint()
    The hint shown when editing a field with no title defined.
    Returns:
      Current emptyTitleHint value. Default value is "[No title specified]"

  - ### setHilitesText

    public FieldPicker setHilitesText(String hilitesText) throws IllegalStateException
    Parameters:
      `hilitesText` - New hilitesText value. Default value is "Highlights..."
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getHilitesText

    public String getHilitesText()
    Returns:
      Current hilitesText value. Default value is "Highlights..."

  - ### getInstructionLabel

    public Label getInstructionLabel() throws IllegalStateException
    A `label` displaying the text assigned as the FieldPicker's `instructions`. Shown across the top of the widget.

    This component is an AutoChild named "instructionLabel". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current instructionLabel value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setInstructions

    public FieldPicker setInstructions(String instructions) throws IllegalStateException
    Parameters:
      `instructions` - New instructions value. Default value is "Drag and drop or use arrows to move fields. Drag reorder to change field order."
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `HTMLString`

  - ### getInstructions

    public String getInstructions()
    Returns:
      Current instructions value. Default value is "Drag and drop or use arrows to move fields. Drag reorder to change field order."
    See Also:
      - `HTMLString`

  - ### setRemoveItemTitle

    public FieldPicker setRemoveItemTitle(String removeItemTitle) throws IllegalStateException
    The title shown on the 'Visible Fields' grid's context menu item, whose click handler puts the selected item back in the 'Available Fields' collection.
    Parameters:
      `removeItemTitle` - New removeItemTitle value. Default value is "Remove"
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getRemoveItemTitle

    public String getRemoveItemTitle()
    The title shown on the 'Visible Fields' grid's context menu item, whose click handler puts the selected item back in the 'Available Fields' collection.
    Returns:
      Current removeItemTitle value. Default value is "Remove"

  - ### setRemoveText

    public FieldPicker setRemoveText(String removeText) throws IllegalStateException
    Parameters:
      `removeText` - New removeText value. Default value is "You are about to remove the field. Are you sure?"
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getRemoveText

    public String getRemoveText()
    Returns:
      Current removeText value. Default value is "You are about to remove the field. Are you sure?"

  - ### setSampleRecord

    public FieldPicker setSampleRecord(Record sampleRecord) throws IllegalStateException
    If a `sampleRecord` is provided, the FieldPicker will show a second column in the Current Fields dialog showing the cell value that will appear for that field given the provided sample record.
    A value of "first" means the first record. If the underlying `dataBoundComponent` is a `TreeGrid`, you can specify "firstOpenLeaf" to use the first open leaf as the sampleRecord (this is often desirable in trees where the first record may be a folder that's used for organizational purposes only and hence would have no actual data for columns other than the tree column).
    Parameters:
      `sampleRecord` - New sampleRecord value. Default value is "first"
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSampleRecord

    public Record getSampleRecord()
    If a `sampleRecord` is provided, the FieldPicker will show a second column in the Current Fields dialog showing the cell value that will appear for that field given the provided sample record.
    A value of "first" means the first record. If the underlying `dataBoundComponent` is a `TreeGrid`, you can specify "firstOpenLeaf" to use the first open leaf as the sampleRecord (this is often desirable in trees where the first record may be a folder that's used for organizational purposes only and hence would have no actual data for columns other than the tree column).
    Returns:
      Current sampleRecord value. Default value is "first"

  - ### setSampleRecord

    public FieldPicker setSampleRecord(DefaultSampleRecord sampleRecord) throws IllegalStateException
    If a `sampleRecord` is provided, the FieldPicker will show a second column in the Current Fields dialog showing the cell value that will appear for that field given the provided sample record.
    A value of "first" means the first record. If the underlying `dataBoundComponent` is a `TreeGrid`, you can specify "firstOpenLeaf" to use the first open leaf as the sampleRecord (this is often desirable in trees where the first record may be a folder that's used for organizational purposes only and hence would have no actual data for columns other than the tree column).
    Parameters:
      `sampleRecord` - New sampleRecord value. Default value is "first"
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSampleRecordAsDefaultSampleRecord

    public DefaultSampleRecord getSampleRecordAsDefaultSampleRecord()
    If a `sampleRecord` is provided, the FieldPicker will show a second column in the Current Fields dialog showing the cell value that will appear for that field given the provided sample record.
    A value of "first" means the first record. If the underlying `dataBoundComponent` is a `TreeGrid`, you can specify "firstOpenLeaf" to use the first open leaf as the sampleRecord (this is often desirable in trees where the first record may be a folder that's used for organizational purposes only and hence would have no actual data for columns other than the tree column).
    Returns:
      Current sampleRecord value. Default value is "first"

  - ### setSampleValueTitle

    public FieldPicker setSampleValueTitle(String sampleValueTitle) throws IllegalStateException
    The title displayed for the sample value property of the current fields
    Parameters:
      `sampleValueTitle` - New sampleValueTitle value. Default value is "Sample Value"
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSampleValueTitle

    public String getSampleValueTitle()
    The title displayed for the sample value property of the current fields
    Returns:
      Current sampleValueTitle value. Default value is "Sample Value"

  - ### getSaveAndExitButton

    public IButton getSaveAndExitButton() throws IllegalStateException
    An AutoChild `button` that saves the current field-set and exits the Field Picker.

    This component is an AutoChild named "saveAndExitButton". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current saveAndExitButton value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setSaveAndExitButtonTitle

    public FieldPicker setSaveAndExitButtonTitle(String saveAndExitButtonTitle) throws IllegalStateException
    The title shown on the Save and Exit button
    Parameters:
      `saveAndExitButtonTitle` - New saveAndExitButtonTitle value. Default value is "Apply"
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getSaveAndExitButtonTitle

    public String getSaveAndExitButtonTitle()
    The title shown on the Save and Exit button
    Returns:
      Current saveAndExitButtonTitle value. Default value is "Apply"

  - ### setShowFieldOrderButtons

    public FieldPicker setShowFieldOrderButtons(boolean showFieldOrderButtons) throws IllegalStateException
    When set to false, hides the right-most set of buttons, used for re-ordering fields in the Visible Fields list.
    Parameters:
      `showFieldOrderButtons` - New showFieldOrderButtons value. Default value is true
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getShowFieldOrderButtons

    public boolean getShowFieldOrderButtons()
    When set to false, hides the right-most set of buttons, used for re-ordering fields in the Visible Fields list.
    Returns:
      Current showFieldOrderButtons value. Default value is true

  - ### setShowHilitesButton

    public FieldPicker setShowHilitesButton(boolean showHilitesButton) throws IllegalStateException
    Shows a "Highlights..." button that shows an interface for editing hilites in the attached DataBoundComponent.
    Parameters:
      `showHilitesButton` - New showHilitesButton value. Default value is true
    Returns:
      `FieldPicker` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getShowHilitesButton

    public boolean getShowHilitesButton()
    Shows a "Highlights..." button that shows an interface for editing hilites in the attached DataBoundComponent.
    Returns:
      Current showHilitesButton value. Default value is true

  - ### setAvailableFields

    public void setAvailableFields(DataSourceField... newFields)
    Provides a new set of available fields.
    Parameters:
      `newFields` -

  - ### setDefaultProperties

    public static void setDefaultProperties(FieldPicker fieldPickerProperties)
    Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

    Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

    Parameters:
      `fieldPickerProperties` - properties that should be used as new defaults when instances of this class are created
    See Also:
      - `SGWTProperties`

  - ### setCallbackCustomizer

    public void setCallbackCustomizer(FieldPickerCallbackCustomizer customizer)
    This method is called during rendering for all events in the visible range - those which would be rendered by default. The customizer should return false to prevent the passed event from appearing in the passed view.
    Parameters:
      `customizer` - the customizer to execute.

  - ### setLogicalStructure

    public LogicalStructureObject setLogicalStructure(FieldPickerLogicalStructure s)
    Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

  - ### getLogicalStructure

    public LogicalStructureObject getLogicalStructure()
    Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    Specified by:
      `getLogicalStructure` in interface `LogicalStructure`
    Overrides:
      `getLogicalStructure` in class `VLayout`